# -*- coding: utf-8 -*-

from openerp.http import request
from eiru_logging import make_info_log


_MODEL= 'account.bank.statement.line'

''' Get Line statement '''
def get_line_statement(statementId):
    from res_partner import get_partner_name
    lines= '''
        SELECT
            line.id as id,
            line.date,
            line.name,
            line.ref,
            line.amount,
            line.partner_id
        FROM account_bank_statement_line as line
        WHERE line.statement_id = %s
    '''
    request.cr.execute(lines,[statementId])

    return [{
        'id': line[0],
        'date': line[1],
        'name': line[2],
        'ref': line[3],
        'amount': line[4],
        'partnerId': line[5],
        'partnerNane': get_partner_name(line[5]) or ''
    } for line in  request.cr.fetchall()]


''' Create Statement line '''
def create_statement_line(values):
    return request.env[_MODEL].sudo().create(values)

''' Modify statement line '''
def modify_statement_line(value):
    ''' DELETED '''
    if (value['linesDeleted']):
        make_info_log('Unlink Statement Line')
        for line in request.env[_MODEL].search([('id', 'in', value['linesDeleted'])]):
            if(line.is_deleted):
                lineWrite={'is_deleted': False}
                write_statement_line(line,lineWrite)

            unlink_statement_line(line)

    ''' UPDATE '''
    if (value['lineUpdate']):
        make_info_log('Write Statement Line')
        for update in value['lineUpdate']:
            lineStatement = request.env[_MODEL].browse(update['id'])
            if (lineStatement):
                lines = {
                    'amount': update['amount'],
                    'date': update['date'],
                    'name': update['name'],
                    'partner_id': update['partnerId'],
                    'ref':update['ref'],
                }
                write_statement_line(lineStatement, lines)

    return {
        'state': True,
        'message': 'Proceso finalizado.'
    }

''' Unlink '''
def unlink_statement_line(line):
    return line.sudo().unlink()

''' Write '''
def write_statement_line(line, value):
    return line.sudo().write(value)
